//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MSScriptControl_OCX.h"
#include "WbemScripting_OCX.h"
#include "TryAUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	// C|[gR|[lgg
	AnsiString s;
	ISWbemServices *srv;
	ISWbemObjectSet *objset;
	VARIANT vi;

	TSWbemLocator *obj = new TSWbemLocator(this);
	srv = obj->ConnectServer(
				L".", //BSTR strServer/*[in,def,opt]*/,
				L"root\\cimv2", //BSTR strNamespace/*[in,def,opt]*/,
				L"", //BSTR strUser/*[in,def,opt]*/,
				L"", //BSTR strPassword/*[in,def,opt]*/,
				L"", //BSTR strLocale/*[in,def,opt]*/,
				L"", //BSTR strAuthority/*[in,def,opt]*/,
				0, //long iSecurityFlags/*[in,def,opt]*/,
				NULL //LPDISPATCH objWbemNamedValueSet/*[in,def,opt]*/
				);
	objset = srv->ExecQuery(
                L"SELECT * FROM Win32_DiskDrive", // strQuery
                L"wql", // strQueryLanguage
                0,   // iFlags
                NULL // objWbemNamedValueSet
                );
	if (objset != NULL) {
		long n = objset->Count;
		for (int i = 0; i < n; i++) {
			VariantInit(&vi);
			ISWbemObject *wo = objset->ItemIndex(i);
			ISWbemProperty *wp = wo->Properties_->Item(L"Caption", 0);
			wp->get_Value(&vi);
			if (vi.vt == VT_BSTR) {
				RichEdit1->Lines->Add(AnsiString(vi.bstrVal));
			}
			VariantClear(&vi);
		}
	}

	delete obj;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	// Variant g
	AnsiString s;
	Variant vX, vY, vZ, vi;

	vX = Variant::CreateObject("WbemScripting.SWbemLocator");
	vY = vX.OleFunction("ConnectServer");
	vZ = vY.OleFunction("ExecQuery", "SELECT * FROM Win32_DiskDrive");
	int n = vZ.OlePropertyGet("Count");
	s.SetLength(0);
	for (int i = 0; i < n; i++) {
		vi = vZ.OleFunction<int>("ItemIndex", i);
		s = vi.OlePropertyGet("Caption");
		RichEdit1->Lines->Add(s);
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
	// Windows  API

	HRESULT hr;
	VARIANT var;
	VARIANT varResult;
	DISPPARAMS dispParams;

	CoInitialize(NULL);

	CLSID clsid;
	hr = CLSIDFromProgID(L"WbemScripting.SWbemLocator", &clsid);
	if (FAILED(hr)) {
		CoUninitialize();
		RichEdit1->Lines->Add(ResultString(hr));
		return;
	}

	IDispatch *pLocator;
	hr = CoCreateInstance(
					clsid, // REFCLSID rclsid
					NULL, // LPUNKNOWN pUnkOuter
					CLSCTX_INPROC_SERVER, // DWORD dwClsContext
						// CLSCTX_LOCAL_SERVER,
						// CLSCTX_REMOTE_SERVER,
					// IID_PPV_ARGS(&pLocator) ==>> G[ɂȂ
					__uuidof(IDispatch), // __uuidof(ϐ) ̓G[
					(void **)&pLocator
					);
	if (FAILED(hr)) {
		CoUninitialize();
		RichEdit1->Lines->Add(ResultString(hr));
		return;
	}

	// vY = vX.OleFunction("ConnectServer");
	DISPID dispid;
	OLECHAR *pNames[1];
	pNames[0] = L"ConnectServer";
	hr = pLocator->GetIDsOfNames(
						IID_NULL, // REFIID riid ([in]Reserved)
						pNames, // OLECHAR FAR* FAR* rgszNames,
						1,
						LOCALE_USER_DEFAULT,
						&dispid
						);
	if (FAILED(hr)) {
		pLocator->Release();
		CoUninitialize();
		RichEdit1->Lines->Add(ResultString(hr));
		return;
	}

	dispParams.cArgs = 0;
	dispParams.rgvarg = NULL;
	dispParams.cNamedArgs = 0;
	dispParams.rgdispidNamedArgs = NULL;
	VariantInit(&varResult);
	hr = pLocator->Invoke(
				dispid, // dispatch ID
				IID_NULL, // Reserved
				LOCALE_SYSTEM_DEFAULT, // locale context
				DISPATCH_METHOD, // _PROPERTYGET, _PROPERTYPUT, _PROPERTYREF
				&dispParams, // pDispParams
				&varResult, // result
				NULL, // exception information
				NULL  // puArgErr
				);
	if (FAILED(hr)) {
		pLocator->Release();
		CoUninitialize();
		RichEdit1->Lines->Add(ResultString(hr));
		return;
	}
	IDispatch *pServer = varResult.pdispVal;
	// VariantClear(&varResult) R[Ǝ pServer->GetIdsOfNames() G[ɂȂ
	// VariantClear()  pServer->Release() R[Ă̂H


	// vZ = vY.OleFunction("ExecQuery", "SELECT * FROM Win32_DiskDrive");
	pNames[0] = L"ExecQuery";
	hr = pServer->GetIDsOfNames(
						IID_NULL, // REFIID riid ([in]Reserved)
						pNames, // OLECHAR FAR* FAR* rgszNames,
						1,
						LOCALE_USER_DEFAULT,
						&dispid
						);
	if (FAILED(hr)) {
		pServer->Release();
		pLocator->Release();
		CoUninitialize();
		RichEdit1->Lines->Add(ResultString(hr));
		return;
	}

	var.vt = VT_BSTR;
	var.bstrVal = SysAllocString(L"SELECT * FROM Win32_DiskDrive");
	dispParams.cArgs = 1;
	dispParams.rgvarg = &var;
	dispParams.cNamedArgs = 0;
	dispParams.rgdispidNamedArgs = NULL;
	VariantInit(&varResult);
	hr = pServer->Invoke(
				dispid, // dispatch ID
				IID_NULL, // Reserved
				LOCALE_SYSTEM_DEFAULT, // locale context
				DISPATCH_METHOD, // _PROPERTYGET, _PROPERTYPUT, _PROPERTYREF
				&dispParams, // pDispParams
				&varResult, // result
				NULL, // exception information
				NULL  // puArgErr
				);
	SysFreeString(var.bstrVal);
	if (FAILED(hr)) {
		pServer->Release();
		pLocator->Release();
		CoUninitialize();
		RichEdit1->Lines->Add(ResultString(hr));
		return;
	}
	IDispatch *pItems = varResult.pdispVal;
	//VariantClear(&varResult);

	pNames[0] = L"Count";
	hr = pItems->GetIDsOfNames(
						IID_NULL, // REFIID riid ([in]Reserved)
						pNames, // OLECHAR FAR* FAR* rgszNames,
						1,
						LOCALE_USER_DEFAULT,
						&dispid
						);
	if (FAILED(hr)) {
		pItems->Release();
		pServer->Release();
		pLocator->Release();
		CoUninitialize();
		RichEdit1->Lines->Add(ResultString(hr));
		return;
	}
	dispParams.cArgs = 0;
	dispParams.rgvarg = NULL;
	dispParams.cNamedArgs = 0;
	dispParams.rgdispidNamedArgs = NULL;
	VariantInit(&varResult);
	hr = pItems->Invoke(
				dispid, // dispatch ID
				IID_NULL, // Reserved
				LOCALE_SYSTEM_DEFAULT, // locale context
				DISPATCH_PROPERTYGET, // _PROPERTYGET, _PROPERTYPUT, _PROPERTYREF
				&dispParams, // pDispParams
				&varResult, // result
				NULL, // exception information
				NULL  // puArgErr
				);
	if (FAILED(hr)) {
		pItems->Release();
		pServer->Release();
		pLocator->Release();
		CoUninitialize();
		RichEdit1->Lines->Add(ResultString(hr));
		return;
	}
	long count = varResult.lVal;
	VariantClear(&varResult);


	pNames[0] = L"ItemIndex";
	hr = pItems->GetIDsOfNames(
						IID_NULL, // REFIID riid ([in]Reserved)
						pNames, // OLECHAR FAR* FAR* rgszNames,
						1,
						LOCALE_USER_DEFAULT,
						&dispid
						);
	if (FAILED(hr)) {
		pItems->Release();
		pServer->Release();
		pLocator->Release();
		CoUninitialize();
		RichEdit1->Lines->Add(ResultString(hr));
		return;
	}
	for (long i = 0; i < count; i++) {
		var.vt = VT_I4;
		var.lVal = i;
		dispParams.cArgs = 1;
		dispParams.rgvarg = &var;
		dispParams.cNamedArgs = 0;
		dispParams.rgdispidNamedArgs = NULL;
		VariantInit(&varResult);
		hr = pItems->Invoke(dispid, IID_NULL, LOCALE_SYSTEM_DEFAULT,
						DISPATCH_METHOD, &dispParams, &varResult, NULL, NULL);
		if (FAILED(hr)) {
			RichEdit1->Lines->Add(ResultString(hr));
			continue;
		}
		IDispatch *pOne = varResult.pdispVal;
		//VariantClear(&varResult);

		DISPID diCaption;
		pNames[0] = L"Caption";
		hr = pOne->GetIDsOfNames(IID_NULL,
								pNames, 1, LOCALE_USER_DEFAULT, &diCaption);
		if (FAILED(hr)) {
			pOne->Release();
			RichEdit1->Lines->Add(ResultString(hr));
			continue;
		}
		dispParams.cArgs = 0;
		dispParams.rgvarg = NULL;
		dispParams.cNamedArgs = 0;
		dispParams.rgdispidNamedArgs = NULL;
		VariantInit(&varResult);
		hr = pOne->Invoke(diCaption, IID_NULL, LOCALE_SYSTEM_DEFAULT,
					DISPATCH_PROPERTYGET, &dispParams, &varResult, NULL, NULL);
		if (SUCCEEDED(hr)) {
			if (varResult.vt == VT_BSTR) {
				RichEdit1->Lines->Add(AnsiString(varResult.bstrVal));
			}
		} else {
			RichEdit1->Lines->Add(ResultString(hr));
		}
		VariantClear(&varResult);

		pOne->Release();
	}

	pItems->Release();
	pServer->Release();
	pLocator->Release();
	CoUninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
	// wsh g
	static char *f_x =
		"Function f_x()\n"
			"rtn = \"\"\n"
			"Set WMI = GetObject(\"winmgmts:\")\n"
			"Set ObjSet = WMI.ExecQuery(\"Select * From Win32_DiskDrive\")\n"
			"For Each Item In ObjSet\n"
				"rtn = rtn & Item.Caption & vbCrLf\n"
			"Next\n"
			"f_x = rtn\n"
		"End Function";
	AnsiString s;

	TScriptControl *scri = new TScriptControl(this);
	scri->Language = L"VBScript";

	scri->AddCode(WideString(f_x).c_bstr());
	s = VarToStr(scri->Eval(WideString("f_x()").c_bstr()));

	delete scri;
	RichEdit1->Lines->Add(s);
}
//---------------------------------------------------------------------------
AnsiString TForm1::ResultString(HRESULT hr)
{
	AnsiString rtn;
	LPVOID lpMsgBuf;
	FormatMessage(
			FORMAT_MESSAGE_ALLOCATE_BUFFER |
			FORMAT_MESSAGE_FROM_SYSTEM |
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			hr,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // ̌
			(LPTSTR) &lpMsgBuf,
			0,
			NULL
			);
	//MessageBox(NULL, (LPCSTR)lpMsgBuf, "Error", MB_OK | MB_ICONINFORMATION);
	rtn = AnsiString((LPCSTR)lpMsgBuf);
	LocalFree(lpMsgBuf);
	return rtn;
}
//---------------------------------------------------------------------------
